#ifndef _ATTRIBS_H__
#define _ATTRIBS_H__

class CAttribs
{
public:
	hword Attr0;
	hword Attr1;
	hword Attr2;
	hword Attr3;


	// Do nothing, the structure should be directed to point to OAM memory externally
	CAttribs() {}
	CAttribs* operator=(uint32* OAM)
	{
		return (CAttribs*)OAM;
	}
	CAttribs* operator=(uint8 Sprite)
	{
		return ((CAttribs*)OAMmem) + Sprite;
	}

	void Clear()
	{
		Attr0 = 0;
		Attr1 = 0;
		Attr2 = 0;
		Attr3 = 0;
		EnableDouble(); // turns out this should be on for some reason
	}

	// A nice accessor for individual Attributes....... Just Incase
	hword& operator[](uint8 i) { return *((&Attr0) + i); }

	// Note: To change a bitset we first zero it then OR the new data in.

	// Get/Set Functions
	// Shape1 (TALL/WIDE)
	hword GetShape1() { return (Attr0>>14) & 3; }
	void SetShape1(hword Shape) { Attr0 &= ~(3<<14); Attr0 |= Shape<<14; }
	// Shape2 (8-64)
	hword GetShape2() { return (Attr1>>14) & 3; }
	void SetShape2(hword Shape) { Attr1 &= ~(3<<14); Attr1 |= Shape<<14; }
	// ColorMode
	hword GetColorMode() { return (Attr0>>13) & 1; }
	void SetColorMode(hword b) { Attr0 &= ~(1<<13); Attr0 |= b<<13; }
	// Priority
	hword GetPriority() { return (Attr2>>10) & 3; }
	void SetPriority(hword b) { Attr2 &= ~(3<<10); Attr2 |= b<<10; }
	// Pallette
	hword GetPallette() { return (Attr2>>12) & 15; }
	void SetPallette(hword b) { Attr2 &= ~(15<<12); Attr2 |= b<<12; }
	// Character
	hword GetCharacter() { return (Attr2) & CHARACTER; }
	void SetCharacter(hword b) { Attr2 &= ~CHARACTER; Attr2 |= b & CHARACTER; }

	// Mosaic
	hword IsMosaic() { return (Attr0 & MOSAIC); }
	void EnableMosaic() { Attr0 |= MOSAIC; }
	void DisableMosaic() { Attr0 &= ~MOSAIC; }
	// Double Size
	hword IsDouble() { return (Attr0 & SIZE_DOUBLE); }
	void EnableDouble() { Attr0 |= SIZE_DOUBLE; }
	void DisableDouble() { Attr0 &= ~SIZE_DOUBLE; }
	// Rotation/Scaling
	hword IsRot() { return (Attr0 & ROTATION_FLAG); }
	void EnableRot() { Attr0 |= ROTATION_FLAG; }
	void DisableRot() { Attr0 &= ~ROTATION_FLAG; }
	// Rotation/Scaling
	hword IsScale() { return (Attr0 & ROTATION_FLAG); }
	void EnableScale() { Attr0 |= ROTATION_FLAG; }
	void DisableScale() { Attr0 &= ~ROTATION_FLAG; }
	// Vertical Flipping
	hword IsVFlip() { return (Attr1 & VERTICAL_FLIP); }
	void EnableVFlip() { Attr1 |= VERTICAL_FLIP; }
	void DisableVFlip() { Attr1 &= ~VERTICAL_FLIP; }
	// Horizontal Flipping
	hword IsHFlip() { return (Attr1 & HORIZONTAL_FLIP); }
	void EnableHFlip() { Attr1 |= HORIZONTAL_FLIP; }
	void DisableHFlip() { Attr1 &= ~HORIZONTAL_FLIP; }

	// Coordinate Y
	hword GetY() { return Attr0 & YCOORD; }
	void SetY(hword y) { Attr0 &= ~YCOORD; Attr0 |= y & YCOORD; } // make sure y is within bounds
	// Coordinate X
	hword GetX() { return Attr1 & XCOORD; }
	void SetX(hword x) { Attr1 &= ~XCOORD; Attr1 |= x & XCOORD; } // make sure x is within bounds
};

#endif // _ATTRIBS_H__

