CFLAGS	= -c -O3
MODEL = -mthumb -mthumb-interwork -mcpu=arm7tdmi -mtune=arm920
EXT = cpp
RESOURCE = continue.o newgame.o optpal.o MathIdle.o MathCrouch.o MathRun.o MathJump.o MathAttack.o MathPal.o Title.o TitPal.o
SOURCE = sincosrad.o Sprite.o GBA_Background.o TileMap.o main.o
PROJECT = Demo
DIR = ..\..\common\inc
COMP = g++

all : $(PROJECT).bin

$(PROJECT).bin : $(PROJECT).elf
	objcopy -O binary $(PROJECT).elf ..\$(PROJECT).bin

$(PROJECT).elf : copy $(RESOURCE) $(SOURCE)
	$(COMP) $(MODEL) -o $(PROJECT).elf $(RESOURCE) $(SOURCE)

main.o : main.$(EXT)
	$(COMP) $(CFLAGS) $(MODEL) main.$(EXT)

TileMap.o : TileMap.$(EXT)
	$(COMP) $(CFLAGS) $(MODEL) TileMap.$(EXT)

Sprite.o : Sprite.$(EXT)
	$(COMP) $(CFLAGS) $(MODEL) Sprite.$(EXT)

GBA_Background.o : GBA_Background.$(EXT)
	$(COMP) $(CFLAGS) $(MODEL) GBA_Background.$(EXT)

sincosrad.o : sincosrad.$(EXT)
	$(COMP) $(CFLAGS) $(MODEL) sincosrad.$(EXT)

optpal.o :
	bin2o .rodata ..\Images\optpal optpal.o
	interflip -mthumb-interwork optpal.o

newgame.o :
    gfx2gba -poptpal -o ..\Images ..\Images\newgame.bmp
	bin2o .rodata ..\Images\newgame.raw newgame.o
	interflip -mthumb-interwork newgame.o

continue.o :
    gfx2gba -o ..\Images ..\Images\continue.bmp
	bin2o .rodata ..\Images\continue.raw continue.o
	interflip -mthumb-interwork continue.o

TitPal.o :
	bin2o .rodata ..\Images\TitPal TitPal.o
	interflip -mthumb-interwork TitPal.o

Title.o :
    gfx2gba -pTitPal -o ..\Images ..\Images\Title.bmp
	bin2o .rodata ..\Images\Title.raw Title.o
	interflip -mthumb-interwork Title.o

MathPal.o :
	bin2o .rodata ..\Images\MathPal MathPal.o
	interflip -mthumb-interwork MathPal.o

MathIdle.o :
    gfx2gba -pMathPal -o ..\Images -t8 ..\Images\MathIdle.bmp
	bin2o .rodata ..\Images\MathIdle.raw MathIdle.o
	interflip -mthumb-interwork MathIdle.o

MathCrouch.o :
    gfx2gba -o ..\Images -t8 ..\Images\MathCrouch.bmp
	bin2o .rodata ..\Images\MathCrouch.raw MathCrouch.o
	interflip -mthumb-interwork MathCrouch.o

MathRun.o :
    gfx2gba -o ..\Images -t8 ..\Images\MathRun.bmp
	bin2o .rodata ..\Images\MathRun.raw MathRun.o
	interflip -mthumb-interwork MathRun.o

MathJump.o :
    gfx2gba -o ..\Images -t8 ..\Images\MathJump.bmp
	bin2o .rodata ..\Images\MathJump.raw MathJump.o
	interflip -mthumb-interwork MathJump.o

MathAttack.o :
    gfx2gba -o ..\Images -t8 ..\Images\MathAttack.bmp
	bin2o .rodata ..\Images\MathAttack.raw MathAttack.o
	interflip -mthumb-interwork MathAttack.o

copy :
	del *.h
	del *.$(EXT)
	xcopy ..\*.h
	xcopy ..\*.cpp *.$(EXT)
	set path=..\..\devkitadv\bin;%path%
