#ifndef _SPRITE_H__
#define _SPRITE_H__

#include "Attribs.h"

#define NOANIM	0xFF
// Since there is only room in memory for 1024 16 color frames, 256 per Sprite
// should be enough
class CAnimation
{
	uint8 m_nAnimations;
	uint8** m_pData;
	uint16* m_nDataSize;

	uint8 m_nCurAnim, m_nNextAnim;
	uint8 m_nCurFrame;
	uint8 m_nDelay, m_nFrameTime;
public:

	CAnimation();
	CAnimation(uint8 Anims, uint8** pData, uint16* pDataSize, uint8 Delay);
	~CAnimation();

	void Init(uint8 Anims, uint8** pData, uint16* pDataSize, uint8 Delay);
	void SetNextAnim(uint8 nAnim);
	void Update();
	uint8 GetCurFrame() { return m_nCurFrame; }
};

class CSprite
{
public:
	CAttribs* m_pAttribs;
	CAnimation m_Anims;
	uint8 m_nSprite;
	uint16 pStartOffset;
	uint8 m_nBlocksPerFrame;

	CSprite();
	~CSprite();

	bool LoadSprite(uint16 Offset, hword Size1, hword Shape, hword Color, uint8 Priority, uint16 Transparent);
	void DrawSprite();
	void MoveSprite(int8 x, int8 y);
	void PutSprite(int16 x, int16 y);

	void InitAnims(uint8 Anims, uint8** pData, uint16* pDataSize, uint8 delay);
	void DoAnim(uint8 nAnim);
};

#endif // _SPRITE_H__

