#ifndef __TILEMAP_H__
#define __TILEMAP_H__

typedef struct _tLevelMap
{
	uint16* pMap;
	uint16 nX, nY;
}LevelMap;

typedef struct _tTileSet
{
	uint16* pTiles;
	uint16 nTiles;
}TileSet;

class GBA_Background;
class CTileMap
{
	GBA_Background* m_pBackground;

	LevelMap m_MapData;
	TileSet m_TileData;
	//uint16* m_pTileRefCount;
	uint16 m_nBigMapX, m_nBigMapY;	// which tile we are on in the big map
	uint16 m_nLtlMapX, m_nLtlMapY;	// what tile on the screen map we are currently on
	int16 m_nMapOffsetX, m_nMapOffsetY;	// what our current scroll is on the memory map (32*32 tiles = 256*256 scroll)


	void CopyColumn(int16 nDir);
	void CopyRow(int16 nDir);
public:

	CTileMap(TileSet* pTileData, LevelMap* pMapData);
	~CTileMap();

	bool InitBg(uint16 sx, uint16 sy, uint8 nLayer);
	void MoveBg(int16 mx, int16 my);
	void DrawBg();
};

#endif // __TILEMAP_H__

