///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
//                    
//        File Name:  main.c 
//      Description:  Main Application
//           Author:  Ash W Matheson 
//                    
//        Copyright:  
//                    Sorce provided as-is.  No support implied or guaranteed 
//                           Yeah ... Right Productions 
//                        20354 83rd Ave, Langley, BC 
//                    
//        Revisions:  
//                    12/08/2002 - AWM - Original version. 
//                    
//  Copyright (c) 2002, Yeah ... Right Productions All rights reserved. 
//                    
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 


#include "keypad.h"
#include "gba.h"
#include "Images.h"
#include "mem.h"


//#include "GBA_Background.h"
// Tile Data
//GBA_Background mainBackground(0);
//GBA_Background BlendBackground(3);
#include "TileMap.h"
CTileMap* pMainMap = 0;
CTileMap* pBackMap = 0;

#include "Sprite.h"
CSprite g_Math;
int x = 0;
int MathX = 120;
int y = 0;
const int gr = 10;
const int jump = 300;
const int hmod = 100;
int vely = 0;
int velx = 0;

const int djump = 3000;
int jumper = 0;

uint16 keys = 0;
#define IsKeyDone(x) (keys & x)
#define KeyDone(x) (keys |= x)
#define KeyClear(x) (keys &= ~x)

void WaitForVRefresh()
{
	static volatile u16* Scanline = (u16*)0x4000006;
	while (*Scanline < 160);
}

void WaitForVRefreshStart()
{
	static volatile u16* Scanline = (u16*)0x4000006;
	while (*Scanline != 160);
}

void HandleInput()
{
	// perform a function based upon a specific keypress
	// Have to do this as a series of If statements, since it's 
	// possible to have multiple keys depressed.

	if (IsKeyDown(KEY_B) && !IsKeyDone(KEY_B))	// A Key is depressed
	{
		// Process the A key
		g_Math.DoAnim(3);
		KeyDone(KEY_B);
	}
	else if (!IsKeyDown(KEY_B))
		KeyClear(KEY_B);

	if (IsKeyDown(KEY_A) && !IsKeyDone(KEY_A))	// B Key is depressed
	{
		// Process the Select key
		if (y <= jumper)
		{
			vely = jump;
			KeyDone(KEY_A);

			if (!jumper)
				jumper = djump;
			else
				jumper = 0;
			g_Math.DoAnim(4);
		}
//		if (y/hmod < 50)
//			vely = jump;
//		else
//			KeyDone(KEY_UP);
		// Process the B key
	}
	else if (!IsKeyDown(KEY_A))
		KeyClear(KEY_A);

	if (IsKeyDown(KEY_SELECT))	// Select Key is depressed
	{
		// Process the Select key
	}

	if (IsKeyDown(KEY_START))	// Start Key is depressed
	{
		// Process the Select key
	}

	if (IsKeyDown(KEY_UP) && !IsKeyDone(KEY_UP))	// Up Direction Key is depressed
	{
	}
	else if (!IsKeyDown(KEY_UP))
		KeyClear(KEY_UP);
	if (y == 0)
	{
		if (!vely)
			jumper = 0;
		if (IsKeyDown(KEY_RIGHT))	// Right Direction Key is depressed
		{
			// Process the Select key
			velx = 2;
			g_Math.m_pAttribs->DisableHFlip();
			g_Math.DoAnim(2);
		}

		if (IsKeyDown(KEY_DOWN))	// Down Direction Key is depressed
		{
			// Process the Select key
			if (!y)
				g_Math.DoAnim(1);
		}
		if (IsKeyDown(KEY_LEFT))	// Left Direction Key is depressed
		{
			// Process the Select key
			velx = -2;
			g_Math.m_pAttribs->EnableHFlip();
			g_Math.DoAnim(2);
		}
	}

	if (IsKeyDown(KEY_R))	// Right trigger button is depressed
	{
		// Process the Select key
	}

	if (IsKeyDown(KEY_L))	// Left trigger button is depressed
	{
		// Process the Select key
	}

	if (!IsKeyDown(KEY_LEFT) && !IsKeyDown(KEY_RIGHT) && !IsKeyDown(KEY_DOWN) && !y)
	{
		g_Math.DoAnim(0);
		velx = 0;
	}

	if (velx)
	{
		if (MathX+velx >= 50 && MathX+velx < 130)
			MathX += velx;
		else
			x += velx;
	}

	if (vely || y)
	{
		y += vely;
		vely -= gr;

		if (y < 0)
		{
			y = 0;
			vely = 0;
		}
	}
	g_Math.PutSprite(MathX, 160-32-(y/hmod));
	pMainMap->MoveBg(velx, 0);
	pBackMap->MoveBg(velx/2, 0);
//	mainBackground.SetMapPos(x, 88);
//	BlendBackground.SetMapPos(x/2, 88);
}

#include "bg.h"
void LoadTileData()
{
	// setup animation pointers and sizes
	uint16 pDataSize[5] = { FILE_DATA_SIZE(___Images_MathIdle_raw),
		FILE_DATA_SIZE(___Images_MathCrouch_raw),
		FILE_DATA_SIZE(___Images_MathRun_raw),
		FILE_DATA_SIZE(___Images_MathAttack_raw),
		FILE_DATA_SIZE(___Images_MathJump_raw) };

	uint8* pData[5] = { FILE_DATA_PTR(uint8, ___Images_MathIdle_raw),
		FILE_DATA_PTR(uint8, ___Images_MathCrouch_raw),
		FILE_DATA_PTR(uint8, ___Images_MathRun_raw),
		FILE_DATA_PTR(uint8, ___Images_MathAttack_raw),
		FILE_DATA_PTR(uint8, ___Images_MathJump_raw)};

	// copy sprite palette into memory
	memcpy(OBJPaletteMem, FILE_DATA_PTR(uint8, ___Images_MathPal), 512);

	g_Math.LoadSprite(0, SIZE_32, 0, COLOR_256, 0, 0);
	g_Math.InitAnims(5, pData, pDataSize, 10);
	g_Math.PutSprite(-1, 160-32);


	// copy tile palette into memory
	memcpy(PaletteMemoryPage, mapcmap, 512);
	// Load up the Tile Set
	TileSet ts = { (uint16*)blockgfx, blocksize/64 };
	LevelMap lm0 = { (uint16*)maparray0, mapsizex, mapsizey };
	pMainMap = new CTileMap(&ts, &lm0);
	pMainMap->InitBg(0, mapsizey - 20, 0);
	LevelMap lm1 = { (uint16*)maparray1, mapsizex, mapsizey };
	pBackMap = new CTileMap(&ts, &lm1);
	pBackMap->InitBg(0, mapsizey - 20, 3);
}

void DoMenu()
{
	// Do title screen first
	SetMode( MODE4 | BG2_ENABLE | OBJ_ENABLE );

	uint16* pImageData = FILE_DATA_PTR(uint16, ___Images_Title_raw);
	uint16* pImagePal = FILE_DATA_PTR(uint16, ___Images_TitPal);

	memcpy(BGPaletteMem, pImagePal, 256*2);
	memcpy(CurrentMemoryPage, pImageData, 240*160);

	while (!IsKeyDown(KEY_A));
	uint8 r, g, b;
	uint16 x, y;
	u16* pPal = BGPaletteMem;
#define chk(n) (n ? n-1 : 0)
	for (y = 0; y < 31; y++)
	{
		WaitForVRefreshStart();
		for (x = 0; x < 256; x++)
		{
			r = R(pPal[x]);
			r = chk(r);
			g = G(pPal[x]);
			g = chk(g);
			b = B(pPal[x]);
			b = chk(b);
			pPal[x] = TORGB(r, g, b);
		}
	}
}

int main(void)
{
	DoMenu();
	// Use mode 1
	SetMode( MODE0 | OBJ_ENABLE | OBJ_MAP_LINEAR );

	// Initialize the Tile Map and Data
	LoadTileData();

	uint16 timer1 = 0;
	while (1)
	{
		if (timer1 > 1000)
		{
			timer1 = 0;
			// When do we start drawing?
			WaitForVRefresh();
			
			// Check for input
			HandleInput();

			// Update the background
			pMainMap->DrawBg();
			pBackMap->DrawBg();
//			mainBackground.Update();
//			BlendBackground.Update();
			//UpdateBackground(&mainBackground);
			//UpdateBackground(&BlendBackground);
			g_Math.DrawSprite();
		}
		timer1++;
	}
	return 1;
}
