#ifndef __MEM_H__
#define __MEM_H__

static void cpymem(void* dDst, const void* dSrc, uint32 nBytes)
{
	uint32* pDst = (uint32*)(dDst);
	const uint32* pSrc = (const uint32*)(dSrc);
	while (nBytes > 4)
	{
		pDst[(nBytes>>2)-1] = pSrc[(nBytes>>2)-1];
		nBytes-=4;
	}

	if (nBytes)
	{
		uint8* pDst8 = (uint8*)(dDst);
		const uint8* pSrc8 = (const uint8*)(dSrc);
		while (nBytes--)
			pDst8[nBytes-1] = pSrc8[nBytes-1];
	}
}

static void zeromem(void* dDst, uint32 nBytes)
{
	uint32* pDst = (uint32*)(dDst);
	while (nBytes > 4)
	{
		pDst[(nBytes>>2)-1] = 0;
		nBytes-=4;
	}

	if (nBytes)
	{
		uint8* pDst8 = (uint8*)(dDst);
		while (nBytes--)
			pDst8[nBytes-1] = 0;
	}
}

#endif // __MEM_H__

